/*
 * Copyright (c) 2016 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __CORECLR_HOST_H__
#define __CORECLR_HOST_H__

extern "C"
{
	typedef int (*coreclr_initialize_ptr)(
			const char* exePath,
			const char* appDomainFriendlyName,
			int propertyCount,
			const char** propertyKeys,
			const char** propertyValues,
			void** hostHandle,
			unsigned int* domainId);

	typedef int (*coreclr_execute_assembly_ptr)(
			void* hostHandle,
			unsigned int domainId,
			int argc,
			const char** argv,
			const char* managedAssemblyPath,
			unsigned int* exitCode);

	typedef int (*coreclr_shutdown_ptr)(
			void* hostHandle,
			unsigned int domainId);

	typedef int (*coreclr_create_delegate_ptr)(
			void* hostHandle,
			unsigned int domainId,
			const char* entryPointAssemblyName,
			const char* entryPointTypeName,
			const char* entryPointMethodName,
			void** delegate);

	typedef bool (*set_environment_variable_ptr)(const char16_t* name,
			const char16_t* value);

	typedef int (*multi_byte_to_wide_char_ptr)(
			unsigned int CodePage,
			unsigned int dwFlags,
			const char * lpMultiByteStr,
			int cbMultiByte,
			char16_t * lpWideCharStr,
			int cchWideChar);
}

#endif /* __CORECLR_HOST_H__ */
